// SketchAfficheXML15P3.pde
// Sketch Processing 3
// 1 5 2018
// Fait par Gerard Paresys
//
// Adaptation de SketchAfficheXML13 pour Processing 3
//
// le fichier "jouineau_sport.TextGrid.xml" au format Praat TextGrid doit 
// être placé dans le dossier data
// 
// Utilise la library minim     (AudioPlayer)

/**
 * Enregistrement audio "jouineau_sport.wav" de Guy Kayser <br>
 * Affiche au choix 5 segmentations différentes du texte faites par Olivier Baude:<br>
 * Taper: 
 P Phonème
 S Syllabe
 M Mot
 H Phonétique
 O Orthographique
 Espace Début audio
 A Aléatoire
 * Chronomètre... Reste à synchroniser l'affichage avec la lecture audio <br>
 * Clic souris dans la fenêtre d'abord 
 */

import ddf.minim.*;

String NomFichierAudio     = "jouineau_sport.wav";
String NomFichierXML = "jouineau_sport.TextGrid.xml";
int NombreCouche = 5; // 0 .. 4
int Couche = 4;  //Orthographe
boolean Alea = false;
boolean AfficheMenu = true;
boolean AfficheChrono = true;

PFont maFonte;
int x;
AudioPlayer player;
Minim minim;
float f, temps, TempsPause;

boolean FichierOuvert = false;
boolean PlayerOuvert = false;
boolean FinVoix = true;
float xmin, xmax;  // Temps en seconde


void setup() {
  size(800, 600);
  maFonte = loadFont("Helvetica-50.vlw");
  // smooth();
  background(255);
  noStroke();
  textAlign(LEFT, TOP); //RIGHT LEFT BOTTOM BASELINE TOP

  Ouverture(NomFichierXML);

  minim = new Minim(this);
  if (loadStrings(NomFichierAudio) == null) { 
    println("9 Le fichier " + NomFichierAudio + " n'existe pas");
    // Probleme = true;
  } else println("Ouverture de: " + NomFichierAudio);
  player = minim.loadFile(NomFichierAudio, 2048);
  PlayerOuvert = true;

  FichierOuvert = true;
  FinVoix = false;
  player.play();
  TempsPause = millis();
  AfficheCouche(Couche);
  frameRate(30);
}

void draw() {
  textFont(maFonte, 14);
  fill(0, 0, 200);
  if (AfficheMenu) {
    x= 670;
    text("Espace Début audio", x, 470);
    text("A Aléatoire", x, 485);
    text("P Phonème", x, 500);
    text("S Syllabe", x, 515);
    text("M Mot", x, 530);
    text("H Phonétique", x, 545);
    text("O Orthographe", x, 560);
    text("Echap Stop", x, 575);
  }

  if (player.isPlaying() == false) {
    player = minim.loadFile(NomFichierAudio, 2048);
    player.play();
  }
  // textFont(maFonte, 24);
  temps = millis() - TempsPause;
  if (AfficheChrono) AfficheTemps(temps);
}

void AfficheCouche(int Couche) {
  println("Couche =  " + Couche);
  background(255);
  textFont(maFonte, 20);
  fill(255, 0, 0, 150);
  println("XMLTier[Couche].length = " + XMLTier[Couche].length);
  for (int i = 0; i < XMLTier[Couche].length; i++) {
    XML kid1 = XMLTier[Couche][i];
    //int n = kid1.getInt("n"); 
    //float xmin = kid1.getFloat("xmin"); 
    //float xmax = kid1.getFloat("xmax"); 
    String Content1 = kid1.getContent();
    if (Content1 == null) {
    } else if (Content1.equals("_") == true) //Elimination des caracteres _ qui separe les segments
    {
    } else {
      if (Alea) text(Content1, random(1, 790), random(1, 590));
      else text(Content1, 5, i * 16);
    }
  }
}

void AfficheTemps(float T) {
  T = T / 1000;
  x = 728;
  fill(0);
  rect(x - 3, 587, 100, 15);
  fill(255);
  text(T + " sec", x, 590);
}

void keyPressed() {
  if ( key == 'p' ) Couche = 0;
  else if (key == 's') Couche = 1;
  else if (key == 'm') Couche = 2;
  else if (key == 'h') Couche = 3;
  else if (key == 'o') Couche = 4;
  else if (key == 'a') Alea = !Alea;
  else if (key == ' ') {
    player.pause();
    TempsPause = millis();
  } else println("key = " + key  + "  Erreur taper Espace, a, p, s, m, h, o ou esc");
  AfficheCouche(Couche);
}

void stop() {
  // always close Minim audio classes when you are done with them
  player.close();
  minim.stop();
  super.stop();
}
